#include<iostream>
#include<algorithm>
#include<iomanip>
#include<cmath>
#include<cstring>
#include<vector>
#include<queue>
#include<stack>
#include<tuple>
#include<set>
#include<map>
#include<random>
#include<chrono>
using namespace std;
const int MAX_N=5e5+4;
int a,b,c,d;
int n,m,q;
int dx[4]={0,1,0,-1};
int dy[4]={1,0,-1,0};
bool ok(int i,int j)
{
    return (((i)&(j))==0);
}
bool used[2005][2005];
void dfs(int u,int v)
{
    used[u][v]=1;
    for(int i=0;i<4;i++)
    {
        int nu=u+dx[i];
        int nv=v+dy[i];
        if(nu<a or nu>c or nv<b or nv>d)continue;
        if(ok(nu,nv)==0)continue;
        if(used[nu][nv])continue;
        dfs(nu,nv);
    }
}
signed main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>a>>b>>c>>d;
        if(a==0 && b==0)
        {
            cout<<1<<"\n";
            continue;
        }
        if(a==c && ((a)&(-a))==a)
        {
            long long rr=d/(2*a)+(d%(2*a)!=0);
            long long ll=(b-1>=0 ? (b-1)/(2*a)+((b-1)%(2*a)!=0) : 0);
            if(b-1>=0 && ok(a,b-1)==1 && ok(a,b)==1)rr--;
            rr-=ll;
            cout<<rr<<"\n";
            continue;
        }
        int ans=0;
        for(int i=a;i<=c;i++)
        {
            for(int j=b;j<=d;j++)
            {
                used[i][j]=0;
            }
        }
        for(int i=a;i<=c;i++)
        {
            for(int j=b;j<=d;j++)
            {
                if(ok(i,j) && used[i][j]==0){ans++;dfs(i,j);}
            }
        }
        cout<<ans<<"\n";
    }

    return 0;
}

