#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 2005;
int grid[MAXN][MAXN];
int dpRows[MAXN][MAXN];
int dpColumns[MAXN][MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    if (n > MAXN && m > MAXN)
    {
        for (int i = 0; i < q; i++)
        {
            int a, b, c, d;
            cin >> a >> b >> c >> d;

            int interval = 2*a;
            int l = (b-b%interval);
            int r = (r-r%interval)+interval-1;

            cout << (r-l+1)/interval << endl;
        }
        return 0;
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            grid[i][j] = ((i&j)==0);
            cout << ((grid[i][j]==1)?"&":"-") << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; i++)
    {
        dpRows[i][0] = grid[i][0];
        for (int j = 1; j < m; j++)
        {
            dpRows[i][j] = dpRows[i][j-1] + ((grid[i][j-1]^1)&(grid[i][j]));
        }
    }

    for (int j = 0; j < m; j++)
    {
        dpColumns[0][j] = grid[0][j];
        for (int i = 1; i < n; i++)
        {
            dpColumns[i][j] = dpColumns[i-1][j] + ((grid[i-1][j]^1)&(grid[i][j]));
        }
    }

    for (int i = 0; i < q; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        int x = dpRows[a][d];
        if (b > 0)
        {
            x -= dpRows[a][b-1];
            x += (grid[a][b-1]&grid[a][b]);
        }

        int y = dpColumns[c][b];
        if (a > 0)
        {
            y -= dpColumns[a-1][b];
            y += (grid[a-1][b]&grid[a][b]);
        }

        int ans = x + y - grid[a][b];

        cout << ans << endl;

    }

    return 0;
}
