#include<iostream>
#include<vector>
#include<queue>
using namespace std;
int n, r;
vector<int> m[5001];
vector<int> path;
int dist[5001];
bool vis[5001];
void bfs()
{
	fill_n(vis, n, false);
	queue<int> q;
	q.push(1);
	while (!q.empty())
	{
		int cur = q.front();
		vis[cur] = true;
		q.pop();
		for (auto v : m[cur])
		{
			if (!vis[v])
			{
				dist[v] = dist[cur] + 1;
				q.emplace(v);
			}
		}
	}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cin >> n >> r;
	long a, b, br = 0;
	for (int i = 0; i < r; i++)
	{
		cin >> a >> b;
		m[b].emplace_back(a);
		m[a].emplace_back(b);
	}
	bfs();
	for (int i = 2; i <= n; i++)
	{
		if (dist[i] == 0)
		{
			int mmin = n, o;
			for (int ii = 1; ii < i; ii++)
			{
				if (dist[ii] != dist[i - 1])
				{
					if (mmin > dist[i - 1] - dist[ii])
					{
						o = ii;
						mmin = dist[i - 1] - dist[ii];
					}
				}

			}
			m[o].push_back(i);
			m[i].push_back(o);
			bfs();
			br += mmin;
		}
	}
	cout << br << "\n";
}

