#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAX_N = 200000;

int n;
vector<pair<int, int>> sections;

void read(){
    cin >> n;
    sections.resize(n);
    for(int i = 0; i < n; i++){
        int h;
        cin >> h;
        sections[i] = {h, i+1};
    }
}

void solve(){
    sort(sections.begin(), sections.end());

    long long sum = 0;
    for(int i = 0; i < n; i++){
        sum += sections[i].first;
        double avg = (double)sum/(i+1);

        if(avg > sections[i].first){
            cout << "impossible";
            return;
        }
    }

    for(int i = 0; i < n; i++){
        if(i == n-1) cout << sections[i].second;
        else cout << sections[i].second << ' ';
    }
}

int main(){
    read();
    solve();
    return 0;
}