#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m;
int used[200000];
vector<int> v[200000];

void read(){
    cin >> n >> m;
    for(int i = 0 ; i < m; i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    for(int i = 0; i < n; i++)used[i] = 0;
}

void bfs(int beg){
    queue<int> q;
    q.push(beg);
    used[beg] = 1;

    while(!q.empty()){
        int w = q.front();
        q.pop();

        for(int i = 0; i < v[w].size(); i++){
            if(!used[v[w][i]]){
                used[v[w][i]] = 1;
                q.push(v[w][i]);
            }
        }
    }
}

int main(){
    read();
    bfs(1);

    int count = 0;

    for(int i = 1; i <= n; i++){
        if(!used[i]){
            bfs(i);
            count ++;
        }
    }

    cout << count;
    return 0;
}