#include<iostream>
using namespace std;
bool used[2010][2010];
void dfs(int cx, int cy, int bx, int by, int ex, int ey)
{
    if(used[cx][cy])return;
    if(cx<bx || cx>ex || cy<by || cy>ey)return;
    if(cx&cy!=0)return;
    used[cx][cy]=1;
    dfs(cx+1,cy,bx,by,ex,ey);
    dfs(cx-1,cy,bx,by,ex,ey);
    dfs(cx,cy+1,bx,by,ex,ey);
    dfs(cx,cy-1,bx,by,ex,ey);
}
int main()
{
    int n,m,q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m>>q;
    for(int t=0;t<q;t++)
    {
        int x1,x2,y1,y2,ans=0;
        cin>>x1>>y1>>x2>>y2;
        for(int i=x1;i<=x2;i++)
        {
            for(int j=y1;j<=y2;j++)
            {
                used[i][j]=0;
            }
        }
        for(int i=x1;i<=x2;i++)
        {
            for(int j=y1;j<=y2;j++)
            {
                if(used[i][j] || i&j!=0)continue;
                dfs(i,j,x1,y1,x2,y2);
                ans++;
            }
        }
        cout<<ans<<"\n";
    }
}